<?php

use Illuminate\Database\Capsule\Manager as Capsule;

if (!defined('WHMCS')) {
    die('This file cannot be accessed directly');
}

require_once __DIR__ . '/functions.php';
require_once __DIR__ . '/lib/billManagerAPI.php';

add_hook('ProductEdit', 1, function($vars) {
    if ($vars["servertype"] == "licensemaster_srv") {
        
        //lmasterBillManagerAPI::ssl_srv_logger("Зашли в CRON ProductEdit с параметрами: ");
        //lmasterBillManagerAPI::ssl_srv_logger($vars);

        $fieldid = Capsule::table('tblcustomfields')->where('relid', '=', $vars['pid'])->where('fieldname', '=', 'License IP') ->pluck('id');
        if (!$fieldid) {
            Capsule::table('tblcustomfields')->insert([
                'id' => null,
                'type' => 'product',
                'relid' => $vars['pid'],
                'fieldname' => 'License IP',
                'fieldtype' => 'text',
                'description' => '',
                'fieldoptions' => '',
                'regexpr' => '/^(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/',
                'adminonly' => '',
                'required' => 'on',
                'showorder' => 'on',
                'showinvoice' => 'on',
                'sortorder' => '10'
            ]);
        }

        $fieldid = Capsule::table('tblcustomfields')->where('relid', '=', $vars['pid'])->where('fieldname', '=', 'License Name') ->pluck('id');
        if (!$fieldid) {
            Capsule::table('tblcustomfields')->insert([
                'id' => null,
                'type' => 'product',
                'relid' => $vars['pid'],
                'fieldname' => 'License Name',
                'fieldtype' => 'text',
                'description' => 'License Name or Hostname',
                'fieldoptions' => '',
                'regexpr' => '/.+/',
                'adminonly' => '',
                'required' => 'on',
                'showorder' => 'on',
                'showinvoice' => 'on',
                'sortorder' => '20'
            ]);
        }

        $fieldid = Capsule::table('tblcustomfields')->where('relid', '=', $vars['pid'])->where('fieldname', '=', 'Order billing ID') ->pluck('id');
        if (!$fieldid) {
            Capsule::table('tblcustomfields')->insert([
                'id' => null,
                'type' => 'product',
                'relid' => $vars['pid'],
                'fieldname' => 'Order billing ID',
                'fieldtype' => 'text',
                'description' => '',
                'fieldoptions' => '',
                'regexpr' => '',
                'adminonly' => 'on',
                'required' => '',
                'showorder' => 'on',
                'showinvoice' => 'on',
                'sortorder' => '30'
            ]);
        }

        $fieldid = Capsule::table('tblcustomfields')->where('relid', '=', $vars['pid'])->where('fieldname', '=', 'LicMaster User ID') ->pluck('id');
        if (!$fieldid) {
            Capsule::table('tblcustomfields')->insert([
                'id' => null,
                'type' => 'product',
                'relid' => $vars['pid'],
                'fieldname' => 'LicMaster User ID',
                'fieldtype' => 'text',
                'description' => '',
                'fieldoptions' => '',
                'regexpr' => '',
                'adminonly' => 'on',
                'required' => '',
                'showorder' => 'on',
                'showinvoice' => 'on',
                'sortorder' => '40'
            ]);
        }
        $fieldid = Capsule::table('tblcustomfields')->where('relid', '=', $vars['pid'])->where('fieldname', '=', 'LicMaster License ID') ->pluck('id');
        if (!$fieldid) {
            Capsule::table('tblcustomfields')->insert([
                'id' => null,
                'type' => 'product',
                'relid' => $vars['pid'],
                'fieldname' => 'LicMaster License ID',
                'fieldtype' => 'text',
                'description' => '',
                'fieldoptions' => '',
                'regexpr' => '',
                'adminonly' => 'on',
                'required' => '',
                'showorder' => 'on',
                'showinvoice' => 'on',
                'sortorder' => '50'
            ]);
        }
        $fieldid = Capsule::table('tblcustomfields')->where('relid', '=', $vars['pid'])->where('fieldname', '=', 'LicMaster License Name') ->pluck('id');
        if (!$fieldid) {
            Capsule::table('tblcustomfields')->insert([
                'id' => null,
                'type' => 'product',
                'relid' => $vars['pid'],
                'fieldname' => 'LicMaster License Name',
                'fieldtype' => 'text',
                'description' => '',
                'fieldoptions' => '',
                'regexpr' => '',
                'adminonly' => 'on',
                'required' => '',
                'showorder' => 'on',
                'showinvoice' => 'on',
                'sortorder' => '60'
            ]);
        }
        $fieldid = Capsule::table('tblcustomfields')->where('relid', '=', $vars['pid'])->where('fieldname', '=', 'LicMaster License Key') ->pluck('id');
        if (!$fieldid) {
            Capsule::table('tblcustomfields')->insert([
                'id' => null,
                'type' => 'product',
                'relid' => $vars['pid'],
                'fieldname' => 'LicMaster License Key',
                'fieldtype' => 'text',
                'description' => '',
                'fieldoptions' => '',
                'regexpr' => '',
                'adminonly' => 'on',
                'required' => '',
                'showorder' => 'on',
                'showinvoice' => 'on',
                'sortorder' => '70'
            ]);
        }


        //Если продукт directadmin - то надо задать поле выбора OS
        if (strpos($vars["configoption4"], "DirectAdmin") !== FALSE) {
            $os = array("CentOS 5 (32 bit)", "CentOS 5 (64 bit)", "CentOS 6 (32 bit)", "CentOS 6 (64 bit)", "CentOS 7 (64 bit)", "Debian 6 (32 bit)", "Debian 6 (64 bit)", "Debian 7 (32 bit)", "Debian 7 (64 bit)", "Debian 8 (64 bit)", "FreeBSD 8 (64 bit)", "FreeBSD 9 (32 bit)", "FreeBSD 9 (64 bit)", "Other (contact support)");
            $fieldid = Capsule::table('tblcustomfields')->where('relid', '=', $vars['pid'])->where('fieldname', '=', 'Operation System') ->pluck('id');
            if (!$fieldid) {
                Capsule::table('tblcustomfields')->insert([
                    'id' => null,
                    'type' => 'product',
                    'relid' => $vars['pid'],
                    'fieldname' => 'Operation System',
                    'fieldtype' => 'dropdown',
                    'description' => '',
                    'fieldoptions' => implode(",", $os),
                    'regexpr' => '',
                    'adminonly' => '',
                    'required' => '',
                    'showorder' => 'on',
                    'showinvoice' => 'on',
                    'sortorder' => '70'
                ]);
            }
        
        }

    }

});

add_hook('ServiceEdit', 1, function($vars) {
    lmasterBillManagerAPI::ssl_srv_logger("Зашли в ServiceEdit с параметрами: ");
    lmasterBillManagerAPI::ssl_srv_logger($vars);

    $lmaster_info = Capsule::table('licensemaster_orders')->where('service_id', $vars["serviceid"])->first();
    if ($lmaster_info->id && $lmaster_info->is_addon == 1) {//значит заказ наш и это аддон

        $product_data = Capsule::table('tblhosting')->select('domain', 'dedicatedip')->where('id', $vars['serviceid'])->first();
        if ($product_data && $product_data->dedicatedip) {

            $module_params = Capsule::table('tbladdonmodules')->where('module', '=', 'licensemaster')->get();
            foreach ($module_params as $mp) {
                if ($mp->setting == "option2") {
                    $params["option2"] = $mp->value;
                } else if ($mp->setting == "option3") {
                    $params["option3"] = $mp->value;
                }
            }

            $bm_params = array(
                "func"                  => "soft.edit",
                "sok"                   => "ok",
                "elid"                  => $lmaster_info->order_id,
                "ip"                    => $product_data->dedicatedip,
                "licname"               => $product_data->domain."_addon"
            );
            lmasterBillManagerAPI::ssl_srv_logger("Параметры изменения лицензии-аддона: ");
            lmasterBillManagerAPI::ssl_srv_logger($params);
            lmasterBillManagerAPI::ssl_srv_logger($bm_params);
            lmasterBillManagerAPI::updateOrder($params, $bm_params);
        }
    }

});