<?php

class lmasterBillManagerAPI
{
    static public function infoCustomer($params, $handle) {
        return self::processRequest('searchCustomerRequest', self::buildParams($params), ['handlePattern' => $handle]);
    }

    static public function processRequest($params) {

        $url = "https://my.isplicense.ru/manager/billmgr?";

        self::ssl_srv_logger("ЗАПРОС В BM! ".$url.http_build_query($params));

        //$url = "https://185.14.30.1:1500/billmgr?";
        $ip = $_SERVER['REMOTE_ADDR'];
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($params));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array("X-Real-IP: $ip"));

        $result = curl_exec($ch);


        if (strpos(http_build_query($params), "certificate.edit") === FALSE) {
            self::ssl_srv_logger("Ответ из BM! ".$result);
        }

        return $result;
    }

    /**
     * @param array $params
     *
     * @return array
     */
    public static function buildParams(array $params, $args) {
        $final = array(
            "out" => "json",
            "sok" => "ok",
            "authinfo" => $params['option2'].":".$params['option3'],
        );
        if ($args) {
            foreach ($args as $k=>$v) {
                $final[$k] = $v;
            }
        }

        return $final;
    }

    static public function searchProductLicense($params) {
        $args = array(
            "func" => "pricelist.export",
        );
        $products = self::processRequest(self::buildParams($params, $args)); 
        $reply = json_decode($products, true);

        $licenses = array();
        foreach ($reply["doc"]["pricelist"] as $item) {
            if ($item["itemtype"]["$"] == 23 || $item["itemtype"]["$"] == 40 || $item["itemtype"]["$"] == 41 || $item["itemtype"]["$"] == 3) {
                $licenses[] = $item;
            }
        }

        return $licenses;
    }

    static public function createLicense($params, $bm_params) {
        $params = self::buildParams($params, $bm_params);
        $rez = self::processRequest($params); 

        if ($rez) {
            $rez = json_decode($rez, true);
            if ($rez["doc"]["item.id"]['$']) {
                return $rez["doc"]["item.id"]['$'];
            }
        }
    }

    static public function cancelSslCert($params) {
        return self::processRequest(
            'cancelSslCertRequest',
            self::buildParams($params),
            [
                'id' => $params['id'],
            ]
        );
    }

    static public function renewSslCert($params, $bm_params) {
        $params = self::buildParams($params, $bm_params);
        $rez = self::processRequest($params); 
    }

    static public function retrieveOrder($params, $bm_params) {
        $params = self::buildParams($params, $bm_params);
        $rez = self::processRequest($params); 

        return $rez;
    }

    static public function updateOrder($params, $bm_params) {
        $params = self::buildParams($params, $bm_params);
        $rez = self::processRequest($params); 

        return $rez;
    }

    public static function ssl_srv_logger($str, $for_email = false) {
        $log = $_SERVER['DOCUMENT_ROOT']."/modules/servers/licensemaster_srv/log.txt";
        if (is_array($str)) {
            $tmpStr = "";
            foreach ($str as $k=>$v) {
                if (!is_object($v)) {
                    $tmpStr .= "$k => $v; ";
                } else {
                    $tmpStr .= "$k => OBJECT; ";
                }
            }
            $str = $tmpStr;
        }

        if ($for_email) {
            return $str;
        }

        $log_str = date("d.m.Y H:i:s")." - ".$str."\r\n";
        $handler = fopen($log, "a");
        fwrite($handler, $log_str);
        fclose($handler);
    }
}
